
class cPlatform{
	public:
		float x, y; //position
		float width; //width of platform
		int lvl;
		GLuint model;
		void draw(){
			if(lvl%2==0|| lvl<0){
				if(lvl<51){
					glBindTexture(GL_TEXTURE_2D, texture[LEVEL1_bg]);
				}
				else if(lvl<101)
					glBindTexture(GL_TEXTURE_2D, texture[LEVEL2_bg]);
				else
					glBindTexture(GL_TEXTURE_2D, texture[LEVEL3_bg]);
				glTranslatef(0.0f, y, 0.0f);
				glCallList(model);
				glTranslatef(0.0f, -y, 0.0f);
			}
			draw_box(x-(width/2),y-FLOOR_HEIGHT,FLOOR_HEIGHT, x+(width/2), y, -FLOOR_HEIGHT, 0.3f, 0.3f, 0.6f);
		}
		void init(){
			if(lvl%10==0){
				width=10;
				x=0;
			}
			else{
				width=floor_width(lvl);
				if(width>FLOOR_MIN_WIDTH+FLOOR_CUT_WIDTH/2){
					width=FLOOR_MIN_WIDTH+(rand()%int((width-FLOOR_MIN_WIDTH)*100))/100;
					width=(floor_width(lvl)*1+width*3)/4.0f;
				}
				x=float((rand()%int((5-width/2)*100)))/100.0f;
				if(rand()%2==0) x*=-1;
			}
			y=(lvl)*(FLOOR_SPACE);
			model=load_mtm("models/bg.mtm", false, model);
		}
		void check(float camY){
			if(y<camY-5.5){
				lvl+=10;
				init();
				}
		}
};

class cCharacter{
	public:
		float x, y, z; //position
		float vx,vy; //velocity x/y
		bool in_air;
		long on_platform;
		
		void move(float delta){
			
			if(keystate[SDLK_LEFT]){
				if(vx>0) vx-=vx*CHAR_SLOWDOWN*delta*0.5;
				if(vx>-1.0f)
					vx-=CHAR_ACCEL*delta;
			}
			
			else if(keystate[SDLK_RIGHT]){
				if(vx<0) vx-=vx*CHAR_SLOWDOWN*delta*0.5;
				if(vx<1.0f)
					vx+=CHAR_ACCEL*delta;
			}
			
			else
				vx-=vx*CHAR_SLOWDOWN*delta;
			
			//printf("vx: %.2f\n", vx);
			if((keystate[SDLK_SPACE]||keystate[SDLK_UP]) && !in_air){ 
				vy+=jump_char(vx);
				in_air=true;
			}
			if(keystate[SDLK_j]&&keystate[SDLK_g])vy+=0.2*delta;
			if(keystate[SDLK_j] && keystate[SDLK_i])vy+=0.15*delta;
			if(keystate[SDLK_j] && keystate[SDLK_n])vy-=vy*0.9*delta;
			x+=move_char(vx)*delta;
			
		}
		
		void collision(cPlatform *floor, float delta){
			//	WALLS	//
			if(x>5-CHAR_WIDTH/2){
				x=5-CHAR_WIDTH/2;
				vx=-roundf1(vx*(1.1f+CHAR_SLOWDOWN), 1);
			}
			else if(x<-5+CHAR_WIDTH/2){
				x=-5+CHAR_WIDTH/2;
				vx=-roundf1(vx*(1.1f+CHAR_SLOWDOWN), 1);
			}
			
			//	GRAVITY + PLATFORMS
			float oldy=y;
			vy-=(GRAVITY/100)*delta;
			y+=vy/10*delta;
			
			for(int i=0; i<10; i++){
				if(floor[i].y>oldy) continue; //if floor is higher than jumper
				if( x+CHAR_WIDTH/2>=floor[i].x-floor[i].width/2 && 
					x-CHAR_WIDTH/2<=floor[i].x+floor[i].width/2 ){
					
					//if jumper's x is on platform
					if(floor[i].y>=y && floor[i].y<=oldy ){ //if stay on platform
						y=floor[i].y;
						vy=0;
						in_air=false;
						on_platform=floor[i].lvl;
						
						break;
					}
				}
			}
			if(vy!=0) in_air=true;
			//	CAMERA MOVE	//
			if(camSpeed==0 && y>+6.0f) camSpeed+=CAMERA_SPEED;
			if(y>camY+2.7) camY+=(y-camY)*0.04*delta;
			
			z=z_char(vy);
		}
	
		void draw(){
			glBindTexture(GL_TEXTURE_2D, texture[JUMPER_TUX]);
			if(vx<0){
				glBegin(GL_QUADS);{
					glNormal3f( 0.0f, 0.0f, 1.0f);
					glTexCoord2f(1.0f, 0.0f); glVertex3f( x+CHAR_WIDTH, y+CHAR_WIDTH*2,  z);
					glTexCoord2f(0.0f, 0.0f); glVertex3f( x-CHAR_WIDTH, y+CHAR_WIDTH*2,  z);
					glTexCoord2f(0.0f, 1.0f); glVertex3f( x-CHAR_WIDTH, y, z);
					glTexCoord2f(1.0f, 1.0f); glVertex3f( x+CHAR_WIDTH, y, z);
				}glEnd();
			}
			else{
				glBegin(GL_QUADS);{
					glNormal3f( 0.0f, 0.0f, 1.0f);
					glTexCoord2f(0.0f, 0.0f); glVertex3f( x+CHAR_WIDTH, y+CHAR_WIDTH*2,  z);
					glTexCoord2f(1.0f, 0.0f); glVertex3f( x-CHAR_WIDTH, y+CHAR_WIDTH*2,  z);
					glTexCoord2f(1.0f, 1.0f); glVertex3f( x-CHAR_WIDTH, y, z);
					glTexCoord2f(0.0f, 1.0f); glVertex3f( x+CHAR_WIDTH, y, z);
				}glEnd();
			}
		}
		
		cCharacter(){
			x=0; y=0.3f;
			in_air=false;
			on_platform=0;
			z=0.4f;
		}
};


class cGame{
	public:
		int players;
		cPlatform floor[10];
		cCharacter jumper;
		int a;
		Uint32 clock;
		bool pause;
		
		//textures & ogl:
		
		GLuint hudTexture[];
		GLfloat LightAmbient[];
		GLfloat LightDiffuse[];
		GLfloat LightPosition[];
		
		void draw(){
			glBindTexture(GL_TEXTURE_2D, texture[LAVA]);
			glBegin(GL_QUADS);{
				glNormal3f( 0.0f, 1.0f, 0.0f);
				glTexCoord2f(0.0f, 0.4f+camY/2); glVertex3f( -10, camY-5.5, -1);
				glTexCoord2f(0.0f, 0.0f+camY/2); glVertex3f( -10, camY-5.5,  1.1f);
				glTexCoord2f(2.0f, 0.0f+camY/2); glVertex3f(  10, camY-5.5,  1.1f);
				glTexCoord2f(2.0f, 0.4f+camY/2); glVertex3f(  10, camY-5.5, -1);
			}glEnd();
			
			glBegin(GL_QUADS);{
				glNormal3f( 0.0f, 0.0f, 1.0f);
				glTexCoord2f(0.0f, 1000.0f+camY/2); glVertex3f( -10, camY-5.5,  1.1f);
				glTexCoord2f(0.0f, 0.0f+camY/2); glVertex3f( -10, camY-5000, 1.1f);
				glTexCoord2f(2.0f, 0.0f+camY/2); glVertex3f(  10, camY-5000, 1.1f);
				glTexCoord2f(2.0f, 1000.0f+camY/2); glVertex3f(  10, camY-5.5,  1.1f);
			}glEnd();
			for(int i=0; i<10; i++) floor[i].draw();
			jumper.draw();
		}
		
		void input(){
			//if(!playReplay)
			SDL_PollEvent(&event);
			{
				keystate = SDL_GetKeyState(NULL);
				if(event.type == SDL_QUIT)
					done=0;
				if(event.type == SDL_KEYDOWN)
				{
					if(event.key.keysym.sym == SDLK_ESCAPE)
						done=0;
						
					if(event.key.keysym.sym == SDLK_p){
						if(pause) pause=false;
						else pause=true;
					}
					if(event.key.keysym.sym == SDLK_r){
						reset();
					}
					if(event.key.keysym.sym == SDLK_q){
						playReplay=false;
					}
				}
			}
				
			
			if(!pause){
				if(!playReplay)
					fprintf(fReplay, "1 %d %d %d %f %f\n", keystate[SDLK_LEFT],keystate[SDLK_RIGHT],keystate[SDLK_SPACE]|keystate[SDLK_UP], jumper.x, jumper.y);
				else{
					char t, l, p, s;
					fscanf(fReplay, "%c %c %c %c %f %f\n", &t, &l, &p, &s, &jumper.x, &jumper.y);
					//printf("%c:%c=%c=%c=\n", l, p, s);
					if(p=='1') keystate[SDLK_RIGHT]=true; else keystate[SDLK_RIGHT]=false;
					if(l=='1') keystate[SDLK_LEFT]=true; else keystate[SDLK_LEFT]=false;
					if(s=='1') keystate[SDLK_UP]=true; else keystate[SDLK_UP]=false;
				}
			}
			//keystate[SDLK_RIGHT]=true;
		}
		
		void step(float delta){
			//input();
			if(!pause){
				jumper.move(delta);
				jumper.collision(floor, delta);
				for(int i=0; i<10; i++){
					floor[i].check(camY);
				}
				if(clock<=SDL_GetTicks()){
					if(camSpeed>0){
						camSpeed+=CAMERA_SPEED_ADD;
						printf("HURRY UP!!!!\n");
					}
					clock+=3000;
				}
					camY+=camSpeed*delta;
				}
			else{
				clock+=Uint32(delta*10.0f);
			}
			
			
		}
		
		void init(long long seed){
			if(!playReplay){
				fReplay=fopen("replay.rpl", "w");
				fprintf(fReplay, "%d\n", seed);
			}
			a=1;
			srand(seed);
			for(int i=0; i<10; i++){
				floor[i].lvl=i;
				floor[i].init();
				floor[i].y=i*FLOOR_SPACE;
			}
			bool makeTexture=false;
			if(texture[LEVEL1_bg]<=0){
				texture[LAVA]=load_texture("textures/lava.png", true);
				texture[CHECKER]=load_texture("textures/checker.png", true);
				texture[LEVEL1_bg]=load_texture("textures/level1_bg.jpg", true);
				texture[LEVEL2_bg]=load_texture("textures/level2_bg.jpg", true);
				texture[LEVEL3_bg]=load_texture("textures/level3_bg.jpg", true);
				texture[JUMPER_TUX]=load_texture("textures/tux.png", true);
				
				GLfloat LightAmbient[]={ 0.2,0.2,0.2, 1.0f };
				GLfloat LightDiffuse[]={ 0.5,0.5,0.6, 1.0f };
				GLfloat LightPosition[]={-2.0f, 0.0f, 2.0f, 1.0f };
				glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
				glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse); 
				glLightfv(GL_LIGHT0, GL_POSITION,LightPosition);
			}
			camSpeed=0;
			camY=3.5;
		}
		void reset(){
			fclose(fReplay);
			init(time(NULL));
			jumper.y=0;
			jumper.x=0;
		}
		
		int hud_letter(const char* letter, int x, int y, Uint8 r,Uint8 g,Uint8 b);
		void hud_text(const char* text, int x, int y, Uint8 r,Uint8 g,Uint8 b);
		void render_hud();
		bool render_scene();
		cGame(){
			camZ=10.0f;
			camY=4.0f;
			camSpeed=0;
			camStart=false;
			pause=false;
			
		}
};

